' BLITZMAX STD-LIB
' ~~  DOBJECT   ~~


Rem
bbdoc: StdObject extension that provides delegation methods
EndRem
Type StdDObject Extends StdObject

	Field _delegate		:Object
	Field _delegatemethods	:TMap
	
	'--------
	'delegate
	'--------
	
	Rem
	bbdoc: Set the delegate
	EndRem
	Method setDelegate( delegate_:Object )
		_delegate = delegate_
		_searchDelegateMethods()
	EndMethod
	
	Rem
	bbdoc: Get the delegate
	EndRem
	Method delegate:Object()
		Return _delegate
	EndMethod
	
	Rem
	bbdoc: Call a delegate method by name
	EndRem
	Method callDelegate:Object( method_:String, args_:Object[]=Null )
		If Not _delegate Return Null
		If Not _delegatemethods _searchDelegateMethods()
		
		Local m_:TMethod = TMethod(_delegatemethods.valueForKey(Lower(method_)))
		If m_
			Return m_.invoke(delegate(), args_)
		EndIf
		Return Null
	EndMethod
	
	'-------
	'private
	'-------
	
	Method _searchDelegateMethods()
		If Not _delegate Return
		If Not _delegatemethods 
			_delegatemethods = CreateMap()
		Else
			_delegatemethods.clear()
		EndIf
		
		Local delegate_:TTypeId = TTypeId.ForObject(_delegate)
		
		Local methods_:String[] = Self.metaDataForKey("delegate").Replace(" ", "").split(",")
		Local count_:Int = methods_.length
		
		For Local i:Int = 0 Until count_
			Local method_:TMethod = delegate_.findMethod(methods_[i])
			If method_ _delegatemethods.insert(Lower(methods_[i]), method_)
		Next
		
		Local methods_strict_:String[] = Self.metaDataForKey("delegate_required").Replace(" ", "").split(",")
		Local count_strict_:Int = methods_strict_.length
		
		Rem
		For Local i:Int = 0 Until count_strict_
			Local method_:TMethod = delegate_.findMethod(methods_strict_[i])
			If method_ 
				_delegatemethods.insert(Lower(methods_strict_[i]), method_)
			Else
				?debug	
					RuntimeError("'"+delegate_.name()+"' does not respond to required delegate method '"+methods_strict_[i]+"'")
				?Not debug
					WriteStderr("'"+delegate_.name()+"' does not respond to required delegate method '"+methods_strict_[i]+"'")
				?
			EndIf
		Next
		endrem
		
	EndMethod

EndType